/*
    ConvertDefaultsIntCmd.h  - set defaults for integer conversion

    Will Eighteen, 2000: will@opaline.demon.co.uk
*/

#ifndef CONVERTDEFAULTSINTCMD_H
#define CONVERTDEFAULTSINTCMD_H

#include "Cmd.h"

typedef void ( *enterCallback ) ( void *, char * );
typedef void ( *cancelCallback ) ( void * );


class LineEdit;


class ConvertDefaultsIntCmd : public Cmd
{
	protected:
		virtual void doCommand();
		virtual void undoCommand();
		
	public:
		ConvertDefaultsIntCmd ( const char *, int active = TRUE );
		virtual const char *const className() { return ( "ConvertDefaultsIntCmd" ); }
		
	private:
		// note 'ok' is mapped to 'enter' by TextEdit
		static void enterCallback ( void *, char * );
		static void cancelCallback ( void * );
		void enter( char * );
		LineEdit *_edit;
		Boolean _popupRealised;
};

#endif

/*
  Notes:
  
  UndoCommand is not implemented here.
  
  The 'cancel' command is defaulted in LineEdit.
  
  'doCommand()' should provide a resource to be displayed.
  'enter' should set a resource from text retrieved from the text widget.
*/
