/*
	FloatToAsciiCmd.h  - convert floating-point to ascii format

	Will Eighteen, 2005: will@opaline.demon.co.uk             
*/

#ifndef FLOATTOASCIICMD_H
#define FLOATTOASCIICMD_H

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


#define BUFSIZE 1024


class FileAccess;


class FloatToAsciiCmd : public BreakCmd
{
	public:
		FloatToAsciiCmd ( char *, int, char *, char * );
		virtual ~FloatToAsciiCmd();
		char *source() { return _srcFile; }
		char *target() { return _dstFile; }
		int error() { return _error; }
		void offset ( int num ) { _offset = num; }
		void scale ( int num ) { _scale = num; }
		void fpDigits ( int num ) { _fpDigits = num; }

	protected:
		void doCommand();
		
	private:
		char _srcFile[BUFSIZE];
		char _dstFile[BUFSIZE];
		char _formatString[16];
		FileAccess *_in;
		FileAccess *_out;
		float _fValue;
		int _once, _percentDone, _error, _offset, _scale, _fpDigits;
};

#endif
