/*
	PakDefs.h - structure definitions

	Will Eighteen, 2006: will@opaline.demon.co.uk
*/

#ifndef PAKDEFS_H
#define PAKDEFS_H


#include "wave/waveclass.h"
#include "WaveDataCmd.h"

#define BUFSIZE 1024


enum FLOCK { ACTIVE, INACTIVE };


/* forward declarations for types */
class GraphIntCmd;
class GraphFltCmd;
class FileAccess;


struct WavePak {
					Wave *pWave;
					int *pIntArray;
					GraphIntCmd *graphCmd;
					unsigned int graphNum;		/* internal use by GraphCmd */
					long intArraySize;
					long startRange;
					long endRange;
					long startSel;
					long endSel;
					long xCurrent;
					long yCurrent;
					long dataOffset;			/* if display not from startRange */
					WaveDataCmd *waveDataCmd;
					unsigned int infoNum;		/* internal use by WaveInfoCmd */
					int fLock;					/* file lock status */
					unsigned int revision;		/* revision number */
					Boolean waveChanged;
					unsigned int templateNum;	/* the template this wave's linked to */
					unsigned int filePerm;
					unsigned int gainTemplate;	/* templatePak index, not */
					unsigned int panTemplate;	/* template number in pak! */
					float gain;					/* fallback for no template */
					float pan;					/* ditto */
					float gainRatio;			/* if template in use, ratio */
					float panRatio;				/* wave/template data */
					unsigned int opMode;		/* all/part mix ctrl; '0' all, '1' seln */
				};

extern List<WavePak> *wavePak;


struct TemplatePak {
						unsigned int templateNum;
						int dataType;
						long dataSize;
						char name[1024];		/* have to use array not ptr */
						char syncFile[1024];	/* or state load loses strings */
						float syncRatio;		/* visual wave/template data ratio */
						GraphIntCmd *graphIntCmd;
						GraphFltCmd *graphFltCmd;
						int graphNum;			/* internal use by GraphCmd */
						long filePos;			/* don't have wave storage here... */
						long intArraySize;
						long fltArraySize;
						long startRange;
						long endRange;
						long startSel;
						long endSel;
						long xCurrent;
						long yIntCurrent;
						float yFltCurrent;
						long dataOffset;		/* if display not from startRange */
						int *pIntArray;
						float *pFloatArray;
						unsigned int infoNum;
						float min;				/* data range */
						float max;
						Boolean templateChanged;
						int fLock;
						FileAccess *file;
					};
					
extern List<TemplatePak> *templatePak;


/* mixPak only used by mixdown; contents set by MixCmd instance. */

struct MixPak {
					unsigned int waveNum;
					long start;
					long end;
				};

extern List<MixPak> *mixPak;

#endif
