// DialogTestWindow.cc - test the InfoDialogManager class

#include "DialogTestWindow.h"
#include <InfoDialogManager.h>

#include <stdio.h>
#include <Xm/PushB.h>


void postDialogCallback ( Widget, XtPointer, XtPointer );

Widget DialogTestWindow::createWorkArea ( Widget parent )
{
	Widget button = XtCreateManagedWidget ( "push_to_test",
											xmPushButtonWidgetClass,
											parent, NULL, 0 );
								
	XtAddCallback ( button, XmNactivateCallback, postDialogCallback, NULL );
	return ( button );
}

void postDialogCallback ( Widget, XtPointer, XtPointer )
{
	static int counter = 1;
	char buf[100];
	sprintf ( buf, "Info Dialog No. %d", counter++ );
	infoDialogManager->post ( buf );
}

/*
  Notes:
  
  This uses a MotifApp framework and displays a button which has a single
  callback posting a dialog when activated.
  
  The class creates a subclass of MainWindow to contain the button widget.
  
  The createWorkArea() member function creates a single XmPushButton widget and
  installs a callback to post a dialog.
*/
